# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define reltag .redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

%global nativeversion 1.5

Name:           jansi
Version:        1.9
Release:        2%{?reltag}%{?dist}
Epoch:          0
Summary:        jansi
License:        ASL 2.0
URL:            http://jansi.fusesource.org
Group:          Development/Java
%if 0
rm -rf jansi/ jansi-1.9.tar.bz2
git clone -q -n git://github.com/fusesource/jansi.git
cd jansi/
git archive --prefix=jansi-1.9/ jansi-project-1.9 | bzip2 > ../jansi-1.9.tar.bz2
cd ../
rhpkg new-sources jansi-1.9.tar.bz2
rm -rf jansi/ jansi-1.9.tar.bz2
rhpkg prep
%endif
Source0:        jansi-1.9.tar.bz2
Patch0:         jansi-vman.patch
Patch1:         jansi-site.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
# XXX: oh well...
%if 0
Requires:       jansi-project = %{epoch}:%{version}-%{release}
%endif
BuildRequires:  hawtjni-runtime >= 0:1.5
BuildRequires:  jansi-native-all = 0:%{nativeversion}
BuildRequires:  junit >= 0:4.7
BuildRequires:  maven-clean-plugin >= 0:2.3
BuildRequires:  maven-uberize-plugin >= 0:1.5
BuildRequires:  maven-surefire-plugin >= 0:2.4.3
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-bundle-plugin >= 0:2.0.1
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-fluido-skin >= 0:1.3.0
BuildRequires:  fuse-javadoc-skin >= 0:1.9
BuildRequires:  fuse-jxr-skin >= 0:1.9
#
# FIXME: bug in jsch (EAP 6.x)
BuildRequires:  oss-parent
# FIXME: bug in guava (EAP 6.x)
BuildRequires:  guava-parent
#
BuildRequires:  maven-default-skin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-scm-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  surefire-junit4 >= 0:2.4.3
BuildArch:      noarch
BuildRoot:      %{_tmppath}/jansi-%{namedversion}-%{release}-root

%description
Jansi is a java library for generating and interpreting ANSI escape sequences.

%package -n jansi-project
Summary:        jansi-project
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       fusesource-pom >= 0:1.8
BuildRequires:  fusesource-pom >= 0:1.8
# XXX: 3.0
BuildRequires:  maven-site-plugin
BuildRequires:  maven-dependency-plugin >= 0:2.3

%description -n jansi-project
Jansi is a java library for generating and interpreting ANSI escape sequences.

%package javadoc
Summary:        Javadoc for jansi
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description javadoc
%{summary}.

%package manual
Summary:        Documents for jansi
Group:          Development/Documentation

%description manual
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://`pwd`/maven2-brew
export MAVEN_OPTS=""
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Denforcer.skip deploy javadoc:aggregate site
pushd maven2-brew
baddirs=`%{_bindir}/find -type d \( -name "[0-9]*" -and -not -name %{namedversion} \)`
for baddir in ${baddirs}; do
    badver=`/bin/basename ${baddir} | %{__sed} "s/\./\\\./g;"`
    %{__mv} ${baddir}/* `/bin/echo ${baddir} | %{__sed} "s/${badver}/%{namedversion}/g;"`/ && %{__rm} -r ${baddir}/
done
popd

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/org/fusesource/jansi/jansi/%{namedversion}/jansi-%{namedversion}.jar %{buildroot}%{_javadir}/jansi-%{namedversion}.jar
%{__cp} -p maven2-brew/org/fusesource/jansi/jansi/%{namedversion}/jansi-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/jansi-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/org/fusesource/jansi/jansi/%{namedversion}/jansi-%{namedversion}-sources.jar %{buildroot}%{_javadir}/jansi-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/org/fusesource/jansi/jansi-project/%{namedversion}/jansi-project-%{namedversion}-site.xml %{buildroot}%{_javadir}/jansi-project-%{namedversion}-site.xml
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/org/fusesource/jansi/jansi/%{namedversion}/jansi-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jansi.pom
%{__cp} -p maven2-brew/org/fusesource/jansi/jansi-project/%{namedversion}/jansi-project-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jansi-project.pom

# depmaps
%add_to_maven_depmap org.fusesource.jansi jansi-project %{namedversion} JPP jansi-project
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/jansi-project
%add_to_maven_depmap org.fusesource.jansi jansi %{namedversion} JPP jansi
[ %{name} = jansi ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/jansi

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/jansi-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/jansi-%{namedversion}
%{__ln_s} jansi-%{namedversion} %{buildroot}%{_javadocdir}/jansi

# manual
%{__mkdir_p} %{buildroot}%{_docdir}/jansi-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/jansi-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/jansi-%{namedversion}/apidocs
%{__ln_s} jansi-%{namedversion} %{buildroot}%{_docdir}/jansi

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post -n jansi-project
%update_maven_depmap

%postun -n jansi-project
%update_maven_depmap

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files -n jansi-project
%defattr(0644,root,root,0755)
%{_javadir}/jansi-project-%{namedversion}-site.xml
%{_javadir}/jansi-project-site.xml
%{_mavenpomdir}/JPP-jansi-project.pom
%{_mavendepmapfragdir}/jansi-project

%files
%defattr(0644,root,root,0755)
%doc changelog.md KEYS license.txt readme.md
%{_javadir}/jansi-%{namedversion}.jar
%{_javadir}/jansi.jar
%exclude %{_javadir}/jansi-%{namedversion}-javadoc.jar
%exclude %{_javadir}/jansi-javadoc.jar
%{_javadir}/jansi-%{namedversion}-sources.jar
%{_javadir}/jansi-sources.jar
%{_mavenpomdir}/JPP-jansi.pom
%{_mavendepmapfragdir}/jansi

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/jansi-%{namedversion}
%{_javadocdir}/jansi

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/jansi-%{namedversion}
%{_docdir}/jansi

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Thu Mar 28 2013 David Walluck <dwalluck@redhat.com> 0:1.9-2
- include in jar: jansi-native-1.5-redhat-1 windows{32,64}

* Tue Mar 12 2013 David Walluck <dwalluck@redhat.com> 0:1.9-1
- 1.9

* Wed Mar 06 2013 David Walluck <dwalluck@redhat.com> 0:1.8-5
- remove some spurious requires
- remove jansi-project requires even though technically correct
- move docs from jansi-project to jansi

* Wed Mar 06 2013 David Walluck <dwalluck@redhat.com> 0:1.8-4
- bundle jansi-native natives

* Wed Mar 06 2013 David Walluck <dwalluck@redhat.com> 0:1.8-3
- build with plugins
- build site
- fix version in dirs

* Tue Mar 05 2013 David Walluck <dwalluck@redhat.com> 0:1.8-2
- fix windows support
- exclude javadoc jars
- apply vman
- enable repolib
- add some docs

* Fri Feb 22 2013 David Walluck <dwalluck@redhat.com> 0:1.8-1
- 1.8

* Fri Jun 20 2011 David Walluck <dwalluck@redhat.com> 0:1.4-1.1
- use maven-jxr

* Tue Dec 21 2010 David Walluck <dwalluck@redhat.com> 0:1.4-1
- release
